/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.instruction;

import ru.ispras.microtesk.model.api.simnml.instruction.AddressingModeImm;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.exception.ConfigurationException;
import ru.ispras.microtesk.model.api.instruction.IInstructionCall;
import ru.ispras.microtesk.model.api.instruction.IInstructionCallBuilderEx;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionCall;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionBase;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.situation.ISituation;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.arm.op.*;
import ru.ispras.microtesk.model.arm.situation.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class InstructionCDP extends InstructionBase
{
    public static final String NAME = "CDP";

    public static final ParamDecl[] PARAMS = new ParamDecl[] 
    {
       new ParamDecl("cond", Condition.INFO),
       new ParamDecl("opcode_1", AddressingModeImm.INFO(nibble)),
       new ParamDecl("crn", AddressingModeImm.INFO(nibble)),
       new ParamDecl("crd", AddressingModeImm.INFO(nibble)),
       new ParamDecl("cpnum", AddressingModeImm.INFO(nibble)),
       new ParamDecl("opcode_2", AddressingModeImm.INFO(new Type(ETypeID.CARD, 3))),
       new ParamDecl("crm", AddressingModeImm.INFO(nibble))
    };

    public static final ISituation.IInfo[] SITUATIONS = new ISituation.IInfo[]
    {
        _Random.INFO
    };

    public InstructionCDP()
    {
        super(NAME, PARAMS, SITUATIONS);
    }

    @Override
    public IInstructionCallBuilderEx createCallBuilder()
    {
        return new Builder(); 
    }

    private class Builder extends CallBuilderBase
    {
        public Builder()
        {
            super(PARAMS);
        }

        @Override
        public IInstructionCall getCall() throws ConfigurationException
        {
            final IAddressingMode cond = getArgument("cond");
            final IAddressingMode opcode_1 = getArgument("opcode_1");
            final IAddressingMode crn = getArgument("crn");
            final IAddressingMode crd = getArgument("crd");
            final IAddressingMode cpnum = getArgument("cpnum");
            final IAddressingMode opcode_2 = getArgument("opcode_2");
            final IAddressingMode crm = getArgument("crm");

            return new InstructionCall(
                __RESETTER,
                new instruction(
                    new CDP(
                        cond,
                        opcode_1.access(),
                        crn.access(),
                        crd.access(),
                        cpnum.access(),
                        opcode_2.access(),
                        crm.access()
                    )
                )
            );
        }
    }
     
}
 