/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.instruction;

import ru.ispras.microtesk.model.api.exception.ConfigurationException;
import ru.ispras.microtesk.model.api.instruction.IInstructionCall;
import ru.ispras.microtesk.model.api.instruction.IInstructionCallBuilderEx;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionCall;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionBase;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.situation.ISituation;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.arm.op.*;
import ru.ispras.microtesk.model.arm.situation.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class InstructionSWP extends InstructionBase
{
    public static final String NAME = "SWP";

    public static final ParamDecl[] PARAMS = new ParamDecl[] 
    {
       new ParamDecl("cond", Condition.INFO),
       new ParamDecl("rn", REG.INFO),
       new ParamDecl("rd", REG.INFO),
       new ParamDecl("rm", REG.INFO)
    };

    public static final ISituation.IInfo[] SITUATIONS = new ISituation.IInfo[]
    {
        _Random.INFO
    };

    public InstructionSWP()
    {
        super(NAME, PARAMS, SITUATIONS);
    }

    @Override
    public IInstructionCallBuilderEx createCallBuilder()
    {
        return new Builder(); 
    }

    private class Builder extends CallBuilderBase
    {
        public Builder()
        {
            super(PARAMS);
        }

        @Override
        public IInstructionCall getCall() throws ConfigurationException
        {
            final IAddressingMode cond = getArgument("cond");
            final IAddressingMode rn = getArgument("rn");
            final IAddressingMode rd = getArgument("rd");
            final IAddressingMode rm = getArgument("rm");

            return new InstructionCall(
                __RESETTER,
                new instruction(
                    new SWP(
                        cond,
                        rn,
                        rd,
                        rm
                    )
                )
            );
        }
    }
     
}
 