/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.mode;

import java.util.Map;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.simnml.instruction.AddressingMode;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class IMMEDIATE extends AddressingMode
{
    public static final String NAME = "IMMEDIATE";

    public static final ParamDecl[] PARAMS = new ParamDecl[]
    {
        new ParamDecl("r", nibble),
        new ParamDecl("c", byte_t)
    };

    public static final IFactory FACTORY = new IFactory()
    {
        @Override
        public IAddressingMode create(Map<String, Data> args)
        {
            return new IMMEDIATE(args);
        }
    };

    public static final Map<String, Type> DECLS = createDeclarations(PARAMS);
    public static final IInfo INFO = new Info(IMMEDIATE.class, NAME, FACTORY, DECLS);

    private final Location r;
    private final Location c;

    public IMMEDIATE(Map<String, Data> args)
    {
        this.r = getArgument("r", DECLS, args);
        this.c = getArgument("c", DECLS, args);
    }

    @Override
    public String syntax()
    {
        return String.format("#%x<<<%x*2", c.load().getRawData().intValue(), r.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%4b%8b", r.load().getRawData().toBinString(), c.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(r.load()) == 0)
        {
            shifter_carry_out.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0x1));
        }
        else
        {
            temp.access().store(DataEngine.execute(EOperatorID.L_ROTATE, DataEngine.coerce(new Type(ETypeID.CARD, 32), c.load()), DataEngine.coerce(new Type(ETypeID.CARD, 32), DataEngine.execute(EOperatorID.MUL, r.load(), DataEngine.valueOf(nibble, 2)))));
            shifter_carry_out.access().store(temp.access().bitField(31, 31).load());
        }
    }

    @Override
    public Location access()
    {
        return new Location(DataEngine.execute(EOperatorID.L_ROTATE, DataEngine.coerce(new Type(ETypeID.CARD, 32), c.load()), DataEngine.coerce(new Type(ETypeID.CARD, 32), DataEngine.execute(EOperatorID.MUL, r.load(), DataEngine.valueOf(nibble, 2)))));
    }
}
 