/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.mode;

import java.util.Map;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.simnml.instruction.AddressingMode;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class LSL_IMMEDIATE extends AddressingMode
{
    public static final String NAME = "LSL_IMMEDIATE";

    public static final ParamDecl[] PARAMS = new ParamDecl[]
    {
        new ParamDecl("r", index),
        new ParamDecl("amount", Bit5)
    };

    public static final IFactory FACTORY = new IFactory()
    {
        @Override
        public IAddressingMode create(Map<String, Data> args)
        {
            return new LSL_IMMEDIATE(args);
        }
    };

    public static final Map<String, Type> DECLS = createDeclarations(PARAMS);
    public static final IInfo INFO = new Info(LSL_IMMEDIATE.class, NAME, FACTORY, DECLS);

    private final Location r;
    private final Location amount;

    public LSL_IMMEDIATE(Map<String, Data> args)
    {
        this.r = getArgument("r", DECLS, args);
        this.amount = getArgument("amount", DECLS, args);
    }

    @Override
    public String syntax()
    {
        return String.format("R%d , LSL #%d", r.load().getRawData().intValue(), amount.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%5b000%4b", amount.load().getRawData().toBinString(), r.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(amount.load()) == 0)
        {
            shifter_carry_out.access().store(CPSR.access().bitField(29, 29).load());
        }
        else
        {
            shifter_carry_out.access().store(GPR.access(DataEngine.intValue(r.load())).bitField(32 - DataEngine.intValue(amount.load()), 32 - DataEngine.intValue(amount.load())).load());
        }
    }

    @Override
    public Location access()
    {
        return new Location(DataEngine.intValue(r.load()) == 15 ? DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.valueOf(word, 4)), DataEngine.coerce(word, amount.load())) : DataEngine.execute(EOperatorID.L_SHIFT, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.coerce(word, amount.load())));
    }
}
 