/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.mode;

import java.util.Map;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.simnml.instruction.AddressingMode;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class LSR_REGISTER extends AddressingMode
{
    public static final String NAME = "LSR_REGISTER";

    public static final ParamDecl[] PARAMS = new ParamDecl[]
    {
        new ParamDecl("r", index),
        new ParamDecl("amount", Bit5)
    };

    public static final IFactory FACTORY = new IFactory()
    {
        @Override
        public IAddressingMode create(Map<String, Data> args)
        {
            return new LSR_REGISTER(args);
        }
    };

    public static final Map<String, Type> DECLS = createDeclarations(PARAMS);
    public static final IInfo INFO = new Info(LSR_REGISTER.class, NAME, FACTORY, DECLS);

    private final Location r;
    private final Location amount;

    public LSR_REGISTER(Map<String, Data> args)
    {
        this.r = getArgument("r", DECLS, args);
        this.amount = getArgument("amount", DECLS, args);
    }

    @Override
    public String syntax()
    {
        return String.format("R%d , LSR R%d", r.load().getRawData().intValue(), amount.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%4b0011%4b", amount.load().getRawData().toBinString(), r.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(GPR.access(DataEngine.intValue(amount.load())).bitField(7, 0).load()) == 0)
        {
            shifter_carry_out.access().store(CPSR.access().bitField(29, 29).load());
        }
        else
        {
            if (DataEngine.intValue(GPR.access(DataEngine.intValue(amount.load())).bitField(7, 0).load()) < 32)
            {
                temp.access().store(DataEngine.execute(EOperatorID.MINUS, GPR.access(DataEngine.intValue(amount.load())).bitField(7, 0).load(), DataEngine.valueOf(new Type(ETypeID.CARD, 8), 1)));
                shifter_carry_out.access().store(GPR.access(DataEngine.intValue(r.load())).bitField(DataEngine.intValue(temp.access().load()), DataEngine.intValue(temp.access().load())).load());
            }
            else
            {
                if (DataEngine.intValue(GPR.access(DataEngine.intValue(amount.load())).bitField(7, 0).load()) == 32)
                {
                    shifter_carry_out.access().store(GPR.access(DataEngine.intValue(r.load())).bitField(31, 31).load());
                }
                else
                {
                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(amount.load())).bitField(7, 0).load()) > 32)
                    {
                        shifter_carry_out.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
                    }
                }
            }
        }
    }

    @Override
    public Location access()
    {
        return new Location(DataEngine.execute(EOperatorID.R_SHIFT, GPR.access(DataEngine.intValue(r.load())).load(), GPR.access(DataEngine.intValue(amount.load())).load()));
    }
}
 