/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class BLX extends Operation
{
    public static final String NAME = "BLX";

    public static final IInfo INFO = new Info(BLX.class, NAME);

    private final Location offset;
    private final Location Hbit;

    public BLX(Location offset, Location Hbit)
    {
        assert Int24.equals(offset.getType());
        assert bit.equals(Hbit.getType());

        this.offset = offset;
        this.Hbit = Hbit;
    }

    @Override
    public String syntax()
    {
        return String.format("BLX %x", offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("1111101%1b%24b", Hbit.load().getRawData().toBinString(), offset.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        GPR.access(14).store(GPR.access(15).load());
        CPSR.access().bitField(5, 5).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
        GPR.access(15).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, DataEngine.coerce(new Type(ETypeID.INT, 32), GPR.access(15).load()), DataEngine.coerce(new Type(ETypeID.INT, 32), DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(new Type(ETypeID.INT, 30), offset.load()), DataEngine.valueOf(new Type(ETypeID.INT, 30), 2)))), DataEngine.coerce(new Type(ETypeID.INT, 32), DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(new Type(ETypeID.CARD, 3), Hbit.load()), DataEngine.valueOf(new Type(ETypeID.CARD, 3), 2)))));
        __CTRL_TRANSFER.set(1);
    }
}
