/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class CDP extends Operation
{
    public static final String NAME = "CDP";

    public static final IInfo INFO = new Info(CDP.class, NAME);

    private final IAddressingMode cond;
    private final Location opcode_1;
    private final Location crn;
    private final Location crd;
    private final Location cpnum;
    private final Location opcode_2;
    private final Location crm;

    public CDP(IAddressingMode cond, Location opcode_1, Location crn, Location crd, Location cpnum, Location opcode_2, Location crm)
    {
        assert Condition.INFO.isSupported(cond);
        assert nibble.equals(opcode_1.getType());
        assert nibble.equals(crn.getType());
        assert nibble.equals(crd.getType());
        assert nibble.equals(cpnum.getType());
        assert new Type(ETypeID.CARD, 3).equals(opcode_2.getType());
        assert nibble.equals(crm.getType());

        this.cond = cond;
        this.opcode_1 = opcode_1;
        this.crn = crn;
        this.crd = crd;
        this.cpnum = cpnum;
        this.opcode_2 = opcode_2;
        this.crm = crm;
    }

    @Override
    public String syntax()
    {
        return String.format("CDP%s p%d, %d, CR%d, CR%d, CR%d, %d", cond.syntax(), cpnum.load().getRawData().intValue(), opcode_1.load().getRawData().intValue(), crd.load().getRawData().intValue(), crn.load().getRawData().intValue(), crm.load().getRawData().intValue(), opcode_2.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s1110%4b%4b%4b%4b%3b0%4b", cond.image(), opcode_1.load().getRawData().toBinString(), crn.load().getRawData().toBinString(), crd.load().getRawData().toBinString(), cpnum.load().getRawData().toBinString(), opcode_2.load().getRawData().toBinString(), crm.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
    }
}
