/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class LDRBT_SCALED_REGISTER_POST_INDEXED extends Operation
{
    public static final String NAME = "LDRBT_SCALED_REGISTER_POST_INDEXED";

    public static final IInfo INFO = new Info(LDRBT_SCALED_REGISTER_POST_INDEXED.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode src1;
    private final Location r;
    private final IAddressingMode shift;
    private final IAddressingMode Ubit;

    public LDRBT_SCALED_REGISTER_POST_INDEXED(IAddressingMode cond, IAddressingMode src1, Location r, IAddressingMode shift, IAddressingMode Ubit)
    {
        assert Condition.INFO.isSupported(cond);
        assert REG.INFO.isSupported(src1);
        assert index.equals(r.getType());
        assert REGISTER_SHIFT_IMMEDIATE.INFO.isSupported(shift);
        assert setU.INFO.isSupported(Ubit);

        this.cond = cond;
        this.src1 = src1;
        this.r = r;
        this.shift = shift;
        this.Ubit = Ubit;
    }

    @Override
    public String syntax()
    {
        return String.format("LDR%sBT %s, [ R%d ], %s%s ", cond.syntax(), src1.syntax(), r.load().getRawData().intValue(), Ubit.syntax(), shift.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s0110%s111%4b%s%s", cond.image(), Ubit.image(), r.load().getRawData().toBinString(), src1.image(), shift.image());
    }

    @Override
    public void action()
    {
        cond.action();
        amode.access().store(GPR.access(DataEngine.intValue(r.load())).load());
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            if (DataEngine.intValue(Ubit.access().load()) == 1)
            {
                GPR.access(DataEngine.intValue(r.load())).store(DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(r.load())).load(), shift.access().load()));
            }
            else
            {
                GPR.access(DataEngine.intValue(r.load())).store(DataEngine.execute(EOperatorID.MINUS, GPR.access(DataEngine.intValue(r.load())).load(), shift.access().load()));
            }
        }
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            temp.access().bitField(7, 0).store(M.access(DataEngine.intValue(amode.access().load())).load());
            temp.access().bitField(31, 8).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
            GPR.access(DataEngine.intValue(src1.access().load())).store(temp.access().load());
            GPR.access(DataEngine.intValue(r.load())).store(amode.access().load());
        }
    }
}
