/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class MLA extends Operation
{
    public static final String NAME = "MLA";

    public static final IInfo INFO = new Info(MLA.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode sets;
    private final IAddressingMode src1;
    private final IAddressingMode src2;
    private final IAddressingMode src3;
    private final IAddressingMode src4;

    public MLA(IAddressingMode cond, IAddressingMode sets, IAddressingMode src1, IAddressingMode src2, IAddressingMode src3, IAddressingMode src4)
    {
        assert Condition.INFO.isSupported(cond);
        assert setS.INFO.isSupported(sets);
        assert REG.INFO.isSupported(src1);
        assert REG.INFO.isSupported(src2);
        assert REG.INFO.isSupported(src3);
        assert REG.INFO.isSupported(src4);

        this.cond = cond;
        this.sets = sets;
        this.src1 = src1;
        this.src2 = src2;
        this.src3 = src3;
        this.src4 = src4;
    }

    @Override
    public String syntax()
    {
        return String.format("MLA%s%s %s, %s, %s, %s", cond.syntax(), sets.syntax(), src1.syntax(), src2.syntax(), src3.syntax(), src4.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s0000001%s%s%s%s1001%s", cond.image(), sets.image(), src1.image(), src4.image(), src3.image(), src2.image());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            GPR.access(DataEngine.intValue(src1.access().load())).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.MUL, GPR.access(DataEngine.intValue(src2.access().load())).load(), GPR.access(DataEngine.intValue(src3.access().load())).load()), GPR.access(DataEngine.intValue(src4.access().load())).load()));
            if (DataEngine.intValue(sets.access().load()) == 1)
            {
                CPSR.access().bitField(31, 31).store(GPR.access(DataEngine.intValue(src1.access().load())).bitField(31, 31).load());
                if (DataEngine.intValue(GPR.access(DataEngine.intValue(src1.access().load())).load()) == 0)
                {
                    CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
                }
                else
                {
                    CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
                }
            }
        }
    }
}
