/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class PLD extends Operation
{
    public static final String NAME = "PLD";

    public static final IInfo INFO = new Info(PLD.class, NAME);

    private final Location ibit;
    private final Location ubit;
    private final Location rn;
    private final Location aamode;

    public PLD(Location ibit, Location ubit, Location rn, Location aamode)
    {
        assert bit.equals(ibit.getType());
        assert bit.equals(ubit.getType());
        assert index.equals(rn.getType());
        assert new Type(ETypeID.CARD, 12).equals(aamode.getType());

        this.ibit = ibit;
        this.ubit = ubit;
        this.rn = rn;
        this.aamode = aamode;
    }

    @Override
    public String syntax()
    {
        return String.format("PLD R%d,0x%x", rn.load().getRawData().intValue(), aamode.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("111101%1b1%1b101%4b1111%12b", ibit.load().getRawData().toBinString(), ubit.load().getRawData().toBinString(), rn.load().getRawData().toBinString(), aamode.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
    }
}
