/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class QDSUB extends Operation
{
    public static final String NAME = "QDSUB";

    public static final IInfo INFO = new Info(QDSUB.class, NAME);

    private final IAddressingMode cond;
    private final Location rn;
    private final Location rd;
    private final Location rm;

    public QDSUB(IAddressingMode cond, Location rn, Location rd, Location rm)
    {
        assert Condition.INFO.isSupported(cond);
        assert index.equals(rn.getType());
        assert index.equals(rd.getType());
        assert index.equals(rm.getType());

        this.cond = cond;
        this.rn = rn;
        this.rd = rd;
        this.rm = rm;
    }

    @Override
    public String syntax()
    {
        return String.format("QDSUB%s R%d, R%d, R%d", cond.syntax(), rd.load().getRawData().intValue(), rm.load().getRawData().intValue(), rn.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s00010110%4b%4b00000101%4b", cond.image(), rn.load().getRawData().toBinString(), rd.load().getRawData().toBinString(), rm.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            op1.access().store(DataEngine.coerce(new Type(ETypeID.INT, 32), GPR.access(DataEngine.intValue(rm.load())).load()));
            op2.access().store(DataEngine.coerce(new Type(ETypeID.INT, 32), GPR.access(DataEngine.intValue(rn.load())).load()));
            sum.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.coerce(new Type(ETypeID.INT, 64), op2.access().load()), DataEngine.coerce(new Type(ETypeID.INT, 64), op2.access().load())));
            if (DataEngine.intValue(sum.access().load()) > 0x7fffffff)
            {
                op2.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 32), 0x7fffffff));
                CPSR.access().bitField(27, 27).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
            }
            else
            {
                if (DataEngine.longValue(sum.access().load()) < 0xffffffff80000001L)
                {
                    op2.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 32), 0x80000001));
                    CPSR.access().bitField(27, 27).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
                }
                else
                {
                    op2.access().store(DataEngine.execute(EOperatorID.MUL, op2.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 32), 2)));
                }
            }
            sum.access().store(DataEngine.execute(EOperatorID.MINUS, DataEngine.coerce(new Type(ETypeID.INT, 64), op1.access().load()), DataEngine.coerce(new Type(ETypeID.INT, 64), op2.access().load())));
            if (DataEngine.intValue(sum.access().load()) > 0x7fffffff)
            {
                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 32), 0x7fffffff));
                CPSR.access().bitField(27, 27).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
            }
            else
            {
                if (DataEngine.longValue(sum.access().load()) < 0xffffffff80000001L)
                {
                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 32), 0x80000001));
                    CPSR.access().bitField(27, 27).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
                }
                else
                {
                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.execute(EOperatorID.MINUS, op1.access().load(), op2.access().load()));
                }
            }
        }
    }
}
