/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class SMLAL extends Operation
{
    public static final String NAME = "SMLAL";

    public static final IInfo INFO = new Info(SMLAL.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode sets;
    private final IAddressingMode low;
    private final IAddressingMode high;
    private final IAddressingMode src1;
    private final IAddressingMode src2;

    public SMLAL(IAddressingMode cond, IAddressingMode sets, IAddressingMode low, IAddressingMode high, IAddressingMode src1, IAddressingMode src2)
    {
        assert Condition.INFO.isSupported(cond);
        assert setS.INFO.isSupported(sets);
        assert REG.INFO.isSupported(low);
        assert REG.INFO.isSupported(high);
        assert REG.INFO.isSupported(src1);
        assert REG.INFO.isSupported(src2);

        this.cond = cond;
        this.sets = sets;
        this.low = low;
        this.high = high;
        this.src1 = src1;
        this.src2 = src2;
    }

    @Override
    public String syntax()
    {
        return String.format("SMLAL%s%s %s, %s, %s, %s", cond.syntax(), sets.syntax(), low.syntax(), high.syntax(), src1.syntax(), src1.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s0000111%s%s%s%s1001%s", cond.image(), sets.image(), high.image(), low.image(), src2.image(), src1.image());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            tempint64.access().store(DataEngine.execute(EOperatorID.MUL, DataEngine.coerce(new Type(ETypeID.INT, 64), GPR.access(DataEngine.intValue(src1.access().load())).load()), DataEngine.coerce(new Type(ETypeID.INT, 64), GPR.access(DataEngine.intValue(src2.access().load())).load())));
            Location.concat(GPR.access(DataEngine.intValue(low.access().load())), carry.access()).store(DataEngine.execute(EOperatorID.PLUS, tempint64.access().bitField(31, 0).load(), DataEngine.coerce(new Type(ETypeID.INT, 32), GPR.access(DataEngine.intValue(low.access().load())).load())));
            GPR.access(DataEngine.intValue(high.access().load())).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, tempint64.access().bitField(63, 32).load(), DataEngine.coerce(new Type(ETypeID.INT, 32), GPR.access(DataEngine.intValue(high.access().load())).load())), DataEngine.coerce(new Type(ETypeID.INT, 32), carry.access().load())));
            if (DataEngine.intValue(sets.access().load()) == 1)
            {
                CPSR.access().bitField(31, 31).store(GPR.access(DataEngine.intValue(high.access().load())).bitField(31, 31).load());
                if (DataEngine.intValue(GPR.access(DataEngine.intValue(high.access().load())).load()) == 0 && DataEngine.intValue(GPR.access(DataEngine.intValue(low.access().load())).load()) == 0)
                {
                    CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
                }
                else
                {
                    CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
                }
            }
        }
    }
}
