/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class SMLAxy extends Operation
{
    public static final String NAME = "SMLAxy";

    public static final IInfo INFO = new Info(SMLAxy.class, NAME);

    private final IAddressingMode cond;
    private final Location rd;
    private final Location rn;
    private final Location rs;
    private final IAddressingMode xbit;
    private final IAddressingMode ybit;
    private final Location rm;

    public SMLAxy(IAddressingMode cond, Location rd, Location rn, Location rs, IAddressingMode xbit, IAddressingMode ybit, Location rm)
    {
        assert Condition.INFO.isSupported(cond);
        assert index.equals(rd.getType());
        assert index.equals(rn.getType());
        assert index.equals(rs.getType());
        assert setX.INFO.isSupported(xbit);
        assert setY.INFO.isSupported(ybit);
        assert index.equals(rm.getType());

        this.cond = cond;
        this.rd = rd;
        this.rn = rn;
        this.rs = rs;
        this.xbit = xbit;
        this.ybit = ybit;
        this.rm = rm;
    }

    @Override
    public String syntax()
    {
        return String.format("SMLA%s%s%s R%d, R%d, R%d, R%d", xbit.syntax(), ybit.syntax(), cond.syntax(), rd.load().getRawData().intValue(), rm.load().getRawData().intValue(), rs.load().getRawData().intValue(), rn.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s00010000%4b%4b%4b1%s%s0%4b", cond.image(), rd.load().getRawData().toBinString(), rn.load().getRawData().toBinString(), rs.load().getRawData().toBinString(), ybit.image(), xbit.image(), rm.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            if (DataEngine.intValue(xbit.access().load()) == 0)
            {
                operand1.access().store(DataEngine.coerce(new Type(ETypeID.INT, 16), GPR.access(DataEngine.intValue(rm.load())).bitField(15, 0).load()));
            }
            else
            {
                operand1.access().store(DataEngine.coerce(new Type(ETypeID.INT, 16), GPR.access(DataEngine.intValue(rm.load())).bitField(31, 16).load()));
            }
            if (DataEngine.intValue(ybit.access().load()) == 0)
            {
                operand2.access().store(DataEngine.coerce(new Type(ETypeID.INT, 16), GPR.access(DataEngine.intValue(rs.load())).bitField(15, 0).load()));
            }
            else
            {
                operand2.access().store(DataEngine.coerce(new Type(ETypeID.INT, 16), GPR.access(DataEngine.intValue(rs.load())).bitField(31, 16).load()));
            }
            Location.concat(GPR.access(DataEngine.intValue(rd.load())), carry.access()).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.coerce(new Type(ETypeID.INT, 32), DataEngine.execute(EOperatorID.MUL, operand1.access().load(), operand2.access().load())), DataEngine.coerce(new Type(ETypeID.INT, 32), GPR.access(DataEngine.intValue(rn.load())).load())));
            if (DataEngine.intValue(carry.access().load()) == 1)
            {
                CPSR.access().bitField(27, 27).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
            }
        }
    }
}
