/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class ANDI extends Operation
{
    public static final String NAME = "ANDI";

    public static final IInfo INFO = new Info(ANDI.class, NAME);

    private final Location rt;
    private final IAddressingMode rs;
    private final IAddressingMode immediate;

    public ANDI(Location rt, IAddressingMode rs, IAddressingMode immediate)
    {
        assert index.equals(rt.getType());
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert IMM16.INFO.isSupported(immediate);

        this.rt = rt;
        this.rs = rs;
        this.immediate = immediate;
    }

    @Override
    public String syntax()
    {
        return String.format("ANDI %d, %s, %s", rt.load().getRawData().intValue(), rs.syntax(), immediate.syntax());
    }

    @Override
    public String image()
    {
        return String.format("001100%s%5b%s", rs.image(), rt.load().getRawData().toBinString(), immediate.image());
    }

    @Override
    public void action()
    {
        tmp_signed_word.access().store(DataEngine.execute(EOperatorID.BIT_AND, immediate.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 16), 0xffff)));
        GPR.access(DataEngine.intValue(rt.load())).store(DataEngine.execute(EOperatorID.BIT_AND, tmp_signed_word.access().load(), rs.access().load()));
    }
}
