/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class BEQ extends Operation
{
    public static final String NAME = "BEQ";

    public static final IInfo INFO = new Info(BEQ.class, NAME);

    private final IAddressingMode rs;
    private final IAddressingMode rt;
    private final IAddressingMode offset;

    public BEQ(IAddressingMode rs, IAddressingMode rt, IAddressingMode offset)
    {
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert REG_IND_ZERO.INFO.isSupported(rt);
        assert IMM16.INFO.isSupported(offset);

        this.rs = rs;
        this.rt = rt;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("BEQ %s, %s, %s", rs.syntax(), rt.syntax(), offset.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000100%s%s%s", rs.image(), rt.image(), offset.image());
    }

    @Override
    public void action()
    {
        if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.EQ, rs.access().load(), rt.access().load())))
        {
            branch.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
            tmp_signed_word.access().store(offset.access().load());
            tmp_signed_word.access().store(DataEngine.execute(EOperatorID.L_SHIFT, tmp_signed_word.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 32), 2)));
            JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.coerce(new Type(ETypeID.INT, 32), NIA.access().load()), tmp_signed_word.access().load()));
        }
    }
}
