/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class DIV extends Operation
{
    public static final String NAME = "DIV";

    public static final IInfo INFO = new Info(DIV.class, NAME);

    private final IAddressingMode rs;
    private final IAddressingMode rt;

    public DIV(IAddressingMode rs, IAddressingMode rt)
    {
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert REG_IND_ZERO.INFO.isSupported(rt);

        this.rs = rs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("DIV %s, %s", rs.syntax(), rt.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%s%s0000000000011010", rs.image(), rt.image());
    }

    @Override
    public void action()
    {
        LO.access().store(DataEngine.execute(EOperatorID.DIV, rs.access().load(), rt.access().load()));
        HI.access().store(DataEngine.execute(EOperatorID.MOD, rs.access().load(), rt.access().load()));
    }

    public void sizecheck()
    {
        tmp_signed_word.access().store(rs.access().load());
        signadjust.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
        if (DataEngine.intValue(tmp_signed_word.access().bitField(31, 31).load()) == 1)
        {
            tmp_signed_word.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.BIT_NOT, tmp_signed_word.access().load()), DataEngine.valueOf(new Type(ETypeID.INT, 32), 1)));
            signadjust.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
        }
        tmp_signed_word.access().store(DataEngine.execute(EOperatorID.BIT_AND, tmp_signed_word.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 32), 0xffffff00)));
        if (DataEngine.intValue(tmp_signed_word.access().load()) == 0x0)
        {
            divsize.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 7));
        }
        else
        {
            tmp_signed_word.access().store(DataEngine.execute(EOperatorID.BIT_AND, tmp_signed_word.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 32), 0xffff0000)));
            if (DataEngine.intValue(tmp_signed_word.access().load()) == 0x0)
            {
                divsize.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 15));
            }
            else
            {
                tmp_signed_word.access().store(DataEngine.execute(EOperatorID.BIT_AND, tmp_signed_word.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 32), 0xff000000)));
                if (DataEngine.intValue(tmp_signed_word.access().load()) == 0x0)
                {
                    divsize.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 23));
                }
                else
                {
                    divsize.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31));
                }
            }
        }
    }
}
