/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class LBU extends Operation
{
    public static final String NAME = "LBU";

    public static final IInfo INFO = new Info(LBU.class, NAME);

    private final IAddressingMode base;
    private final IAddressingMode rt;
    private final IAddressingMode offset;

    public LBU(IAddressingMode base, IAddressingMode rt, IAddressingMode offset)
    {
        assert REG_IND_ZERO.INFO.isSupported(base);
        assert REG_IND.INFO.isSupported(rt);
        assert IMM16.INFO.isSupported(offset);

        this.base = base;
        this.rt = rt;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("LBU %s, %s(%s)", rt.syntax(), offset.syntax(), base.syntax());
    }

    @Override
    public String image()
    {
        return String.format("100100%s%s%s", base.image(), rt.image(), offset.image());
    }

    @Override
    public void action()
    {
        EA.access().store(DataEngine.execute(EOperatorID.PLUS, base.access().load(), DataEngine.coerce(signed_long, offset.access().load())));
        tmp_unsigned_byte.access().store(M.access(DataEngine.intValue(EA.access().load())).load());
        GPR.access(DataEngine.intValue(rt.access().load())).store(tmp_unsigned_byte.access().load());
    }
}
