/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class MOVE extends Operation
{
    public static final String NAME = "MOVE";

    public static final IInfo INFO = new Info(MOVE.class, NAME);

    private final Location rd;
    private final IAddressingMode rs;

    public MOVE(Location rd, IAddressingMode rs)
    {
        assert index.equals(rd.getType());
        assert REG_IND_ZERO.INFO.isSupported(rs);

        this.rd = rd;
        this.rs = rs;
    }

    @Override
    public String syntax()
    {
        return String.format("MOVE %d, %s", rd.load().getRawData().intValue(), rs.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%5b00000%s00000100001", rd.load().getRawData().toBinString(), rs.image());
    }

    @Override
    public void action()
    {
        GPR.access(DataEngine.intValue(rd.load())).store(rs.access().load());
    }
}
