/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class SRLV extends Operation
{
    public static final String NAME = "SRLV";

    public static final IInfo INFO = new Info(SRLV.class, NAME);

    private final Location rd;
    private final IAddressingMode rs;
    private final IAddressingMode rt;

    public SRLV(Location rd, IAddressingMode rs, IAddressingMode rt)
    {
        assert index.equals(rd.getType());
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert REG_IND_ZERO.INFO.isSupported(rt);

        this.rd = rd;
        this.rs = rs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("SRLV %d, %s, %s", rd.load().getRawData().intValue(), rs.syntax(), rt.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%s%s%5b00000000110", rs.image(), rt.image(), rd.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        tmp_unsigned_byte.access().store(rs.access().bitField(4, 0).load());
        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.execute(EOperatorID.R_SHIFT, rt.access().load(), DataEngine.coerce(signed_long, tmp_unsigned_byte.access().load())));
        if (DataEngine.intValue(tmp_unsigned_byte.access().load()) > 0)
        {
            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.execute(EOperatorID.BIT_AND, GPR.access(DataEngine.intValue(rd.load())).load(), DataEngine.coerce(signed_long, DataEngine.execute(EOperatorID.R_SHIFT, DataEngine.valueOf(new Type(ETypeID.CARD, 8), 0x7fffffff), DataEngine.execute(EOperatorID.MINUS, tmp_unsigned_byte.access().load(), DataEngine.valueOf(new Type(ETypeID.CARD, 8), 1))))));
        }
    }
}
