/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class SUBU extends Operation
{
    public static final String NAME = "SUBU";

    public static final IInfo INFO = new Info(SUBU.class, NAME);

    private final Location rd;
    private final IAddressingMode rs;
    private final IAddressingMode rt;

    public SUBU(Location rd, IAddressingMode rs, IAddressingMode rt)
    {
        assert index.equals(rd.getType());
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert REG_IND_ZERO.INFO.isSupported(rt);

        this.rd = rd;
        this.rs = rs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("SUBU %d, %s, %s", rd.load().getRawData().intValue(), rs.syntax(), rt.syntax());
    }

    @Override
    public void action()
    {
        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.execute(EOperatorID.MINUS, rs.access().load(), rt.access().load()));
    }
}
