/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class TEQ extends Operation
{
    public static final String NAME = "TEQ";

    public static final IInfo INFO = new Info(TEQ.class, NAME);

    private final IAddressingMode rs;
    private final IAddressingMode rt;

    public TEQ(IAddressingMode rs, IAddressingMode rt)
    {
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert REG_IND_ZERO.INFO.isSupported(rt);

        this.rs = rs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("TEQ %s, %s", rs.syntax(), rt.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%s%s0000000111110100", rs.image(), rt.image());
    }

    @Override
    public void action()
    {
    }
}
