/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.shared;

import ru.ispras.microtesk.model.api.type.ETypeID;
import ru.ispras.microtesk.model.api.type.Type;
import ru.ispras.microtesk.model.api.memory.EMemoryKind;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.state.Status;
import ru.ispras.microtesk.model.api.state.Resetter;

public final class Shared
{
    private Shared() {}

    public static final String byte_order = "big";
    public static final String PC = "NIA";
    public static final String SP = "GPR[29]";

    public static final int REGS = 5;

    public static final Type bit = new Type(ETypeID.CARD, 1);
    public static final Type byte_t = new Type(ETypeID.CARD, 8);
    public static final Type word = new Type(ETypeID.CARD, 32);
    public static final Type long_t = new Type(ETypeID.CARD, 32);
    public static final Type signed_long = new Type(ETypeID.INT, 32);
    public static final Type address = new Type(ETypeID.CARD, 32);
    public static final Type index = new Type(ETypeID.CARD, REGS);
    public static final Type breakcode = new Type(ETypeID.CARD, 20);
    public static final Type cond_code = new Type(ETypeID.CARD, 3);
    public static final Type cond = new Type(ETypeID.CARD, 4);

    public static final Memory M = new Memory(EMemoryKind.MEM, "M", byte_t, (int)Math.pow(2, 10));
    public static final Memory GPR = new Memory(EMemoryKind.REG, "GPR", signed_long, (int)Math.pow(2, REGS));
    public static final Memory LO = new Memory(EMemoryKind.REG, "LO", signed_long, 1);
    public static final Memory NIA = new Memory(EMemoryKind.REG, "NIA", long_t, 1);
    public static final Memory HI = new Memory(EMemoryKind.REG, "HI", signed_long, 1);
    public static final Memory CIA = new Memory(EMemoryKind.MEM, "CIA", long_t, 1);
    public static final Memory FPSCR = new Memory(EMemoryKind.REG, "FPSCR", long_t, 1);
    public static final Memory FCCR = new Memory(EMemoryKind.REG, "FCCR", long_t, 1);
    public static final Memory tmp_signed_byte = new Memory(EMemoryKind.MEM, "tmp_signed_byte", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_unsigned_byte = new Memory(EMemoryKind.MEM, "tmp_unsigned_byte", new Type(ETypeID.CARD, 8), 1);
    public static final Memory tmp_signed_half_word = new Memory(EMemoryKind.MEM, "tmp_signed_half_word", new Type(ETypeID.INT, 16), 1);
    public static final Memory tmp_unsigned_half_word = new Memory(EMemoryKind.MEM, "tmp_unsigned_half_word", new Type(ETypeID.CARD, 16), 1);
    public static final Memory tmp_signed_word = new Memory(EMemoryKind.MEM, "tmp_signed_word", new Type(ETypeID.INT, 32), 1);
    public static final Memory tmp_signed_word1 = new Memory(EMemoryKind.MEM, "tmp_signed_word1", new Type(ETypeID.INT, 32), 1);
    public static final Memory tmp_unsigned_word = new Memory(EMemoryKind.MEM, "tmp_unsigned_word", new Type(ETypeID.CARD, 32), 1);
    public static final Memory tmp_double_word = new Memory(EMemoryKind.MEM, "tmp_double_word", new Type(ETypeID.CARD, 64), 1);
    public static final Memory TMP_SDWORD = new Memory(EMemoryKind.MEM, "TMP_SDWORD", new Type(ETypeID.INT, 64), 1);
    public static final Memory overflow_bit = new Memory(EMemoryKind.MEM, "overflow_bit", bit, 1);
    public static final Memory EA = new Memory(EMemoryKind.MEM, "EA", address, 1);
    public static final Memory tmp_div = new Memory(EMemoryKind.MEM, "tmp_div", new Type(ETypeID.INT, 64), 1);
    public static final Memory mulsize = new Memory(EMemoryKind.MEM, "mulsize", bit, 1);
    public static final Memory multsize = new Memory(EMemoryKind.MEM, "multsize", bit, 1);
    public static final Memory divsize = new Memory(EMemoryKind.MEM, "divsize", new Type(ETypeID.CARD, 5), 1);
    public static final Memory JMPADDR = new Memory(EMemoryKind.MEM, "JMPADDR", long_t, 1);
    public static final Memory branch = new Memory(EMemoryKind.MEM, "branch", bit, 1);
    public static final Memory signadjust = new Memory(EMemoryKind.MEM, "signadjust", bit, 1);
    public static final Memory likely = new Memory(EMemoryKind.MEM, "likely", new Type(ETypeID.CARD, 2), 1);
    public static final Memory tmp_signed_half_word_A0 = new Memory(EMemoryKind.MEM, "tmp_signed_half_word_A0", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_signed_half_word_A1 = new Memory(EMemoryKind.MEM, "tmp_signed_half_word_A1", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_unsigned_half_word_A0 = new Memory(EMemoryKind.MEM, "tmp_unsigned_half_word_A0", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_unsigned_half_word_A1 = new Memory(EMemoryKind.MEM, "tmp_unsigned_half_word_A1", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_signed_word_A0 = new Memory(EMemoryKind.MEM, "tmp_signed_word_A0", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_signed_word_A1 = new Memory(EMemoryKind.MEM, "tmp_signed_word_A1", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_signed_word_A2 = new Memory(EMemoryKind.MEM, "tmp_signed_word_A2", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_signed_word_A3 = new Memory(EMemoryKind.MEM, "tmp_signed_word_A3", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_unsigned_word_A0 = new Memory(EMemoryKind.MEM, "tmp_unsigned_word_A0", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_unsigned_word_A1 = new Memory(EMemoryKind.MEM, "tmp_unsigned_word_A1", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_unsigned_word_A2 = new Memory(EMemoryKind.MEM, "tmp_unsigned_word_A2", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_unsigned_word_A3 = new Memory(EMemoryKind.MEM, "tmp_unsigned_word_A3", new Type(ETypeID.INT, 8), 1);
    public static final Memory tmp_double_word_A0 = new Memory(EMemoryKind.MEM, "tmp_double_word_A0", new Type(ETypeID.CARD, 16), 1);
    public static final Memory tmp_double_word_A1 = new Memory(EMemoryKind.MEM, "tmp_double_word_A1", new Type(ETypeID.CARD, 16), 1);

    public static final Memory[] __REGISTERS = {GPR, LO, NIA, HI, FPSCR, FCCR};
    public static final Memory[] __MEMORY = {M, CIA, tmp_signed_byte, tmp_unsigned_byte, tmp_signed_half_word, tmp_unsigned_half_word, tmp_signed_word, tmp_signed_word1, tmp_unsigned_word, tmp_double_word, TMP_SDWORD, overflow_bit, EA, tmp_div, mulsize, multsize, divsize, JMPADDR, branch, signadjust, likely, tmp_signed_half_word_A0, tmp_signed_half_word_A1, tmp_unsigned_half_word_A0, tmp_unsigned_half_word_A1, tmp_signed_word_A0, tmp_signed_word_A1, tmp_signed_word_A2, tmp_signed_word_A3, tmp_unsigned_word_A0, tmp_unsigned_word_A1, tmp_unsigned_word_A2, tmp_unsigned_word_A3, tmp_double_word_A0, tmp_double_word_A1};
    public static final Memory[] __VARIABLES = {};
    public static final Label[] __LABELS = {new Label("PC", NIA, 0), new Label("SP", GPR, 29)};

    public static final Status __CTRL_TRANSFER = new Status("__CTRL_TRANSFER", 0);
    public static final Status[] __STATUSES = {__CTRL_TRANSFER};

    public static final Resetter __RESETTER = new Resetter(__VARIABLES, __STATUSES);
}
 